// $Id: indexer.C,v 1.1.1.1 2002/03/24 12:37:01 dvermeir Exp $
#include <fstream>
#include <stdexcept>
#include <dvnet/serversocket.h>
#include <dvutil/makedaemon.h>

#include "server.h"

int
main( int argc , char* argv[] ) {
static const string usage("usage: indexer config-file-name");

try {
  // Get configuration parameters.
  if (argc!=2)
    throw runtime_error(usage);
  const string	config_fn(argv[1]);

  Server	server(config_fn);

  // Start server, throws an exception upon failure.
  Dv::Net::ServerSocket ssocket(server.port());

  Dv::Util::make_daemon();

  bool more(true);

  // This is a single threaded server.
  while (more) {
    Dv::Util::ref<Dv::Net::Socket>
    // A delay of 5 sec on the client should prevent some dos attacks.
    client(ssocket.accept(5000));
  
    server.log() << "accept from " 
    		 << client->port() << '@' << client->host() << endl;
  
    more = server.serve(*client);
    }
  return 0;
  }
catch (exception& e) {
  cerr << e.what() << endl;
  return 2;
  }
return 0;
}
