// $Id: stringpool.C,v 1.1.1.1 2002/03/24 12:37:02 dvermeir Exp $
#include "stringpool.h"

StringPool::StringPool() {
}

StringPool::~StringPool() {
for (PtrSet::const_iterator i=pool_.begin(); i!=pool_.end(); ++i)
  delete (*i);
}

const string*
StringPool::operator()(const string& s) const {
PtrSet::const_iterator i = pool_.find(&s);
return (i==pool_.end() ? 0 : *i);
}

const string*
StringPool::operator[](const string& s) {
return *(pool_.insert(new string(s)).first);
}

bool
StringPool::compare::operator()(const string* s1, 
  const string* s2) const throw (runtime_error) {
if ((s1 == 0) || (s2 == 0) )
  throw runtime_error("StringPool::Compare(): null argument");
return *s1 < *s2;
}

void
StringPool::remove(const string& s) {
const string* ps((*this)(s));
if (ps)
  pool_.erase(ps);
}
