#!/bin/sh
base=test-ffiles-1
here=`pwd`
echo "simple test"
d=${base}-dir
a=${base}-answer
##########################################################
# start with fresh database
##########################################################
rm -f /tmp/test.tdx /tmp/textindexer.log
##########################################################
# make directory and files ${d}/a, ${d}/b ${d}/c
##########################################################
rm -fr $d
mkdir ${d}
cat >${d}/a <<EOF
# should match 
een not twee have not drie
EOF
cat >${d}/b <<EOF
# should not match 
een not twee vier have not drie
EOF
cat >${d}/c <<EOF
# should not match
een not twee vijf have not drie
EOF
##########################################################
# start indexer, add ${d}
##########################################################
echo "+++ stop indexer"
ffiles localhost 7777 stop
echo "+++ clean files"
rm -f /tmp/test.tdx /tmp/textindexer.log
echo "+++ start indexer"
./indexer indexer.config
sleep 2
echo "+++ add"
ffiles localhost 7777 add ${d}
echo "+++ save"
ffiles localhost 7777 save
##########################################################
# do query and stop
##########################################################
echo "+++ query"
ffiles localhost 7777 query '"een twee drie"' >${a}
echo "+++ stop indexer"
ffiles localhost 7777 stop
##########################################################
# verify query result
answer=`cat ${a}`
expect=${here}/${d}/a
if [ "${answer}" = ${expect} ] 
then exit 0;
fi
echo "got ${answer}"
echo "expected ${expect}"
exit 1;

