#!/bin/sh
base=test-ffiles-2
here=`pwd`
echo "simple test"
f=/tmp/${base}-file
a=${base}-answer
sentence="het spaanse graan heeft de orkaan doorstaan"
##########################################################
# make special file ${a}
##########################################################
cat >${f} <<EOF
# should match 
${sentence}
EOF
##########################################################
# start indexer
##########################################################
echo "+++ stop indexer"
ffiles localhost 7777 stop
echo "+++ clean files"
rm -f /tmp/test.tdx /tmp/textindexer.log
echo "+++ start indexer"
./indexer indexer.config 
sleep 3
echo "+++ add"
ffiles localhost 7777 add /usr/doc
ffiles localhost 7777 add ${f}
echo "+++ save"
ffiles localhost 7777 save
##########################################################
# do query and stop
##########################################################
echo "+++ query"
ffiles localhost 7777 query "${sentence}" >${a}
echo "+++ stop indexer"
ffiles localhost 7777 stop
##########################################################
# verify query result
answer=`cat ${a}`
expect=${f}
if [ "${answer}" = ${expect} ] 
then exit 0;
fi
echo "got ${answer}"
echo "expected ${expect}"
exit 1;

