// $Id: test-index-query.C,v 1.1.1.1 2002/03/24 12:37:03 dvermeir Exp $
#include <fstream>
#include <iterator>
#include "index.h"
#include "word.h"

int
main() {
try {
  static const string ifn("stringpool.C");
  Index index(6);
  
  ifstream ifs(ifn.c_str());
  index.insert(ifn, ifs);

  Index::Strings query;
  Index::Files	result;

  ifstream is(ifn.c_str());
  for (istream_iterator<Word> i = istream_iterator<Word>(is);
     i != istream_iterator<Word>();
     ++i)
    query.insert(*i);

  index.query(query,result);
  if (result.size() != 1) {
    cerr << "result.size() = " << result.size() << endl;
    throw runtime_error("unexpected result size (expected: 1)");
    }
  }
catch (exception& e) {
  cerr << e.what() << endl;
  return 1;
  }
return 0;
}
