// $Id: test-server.C,v 1.1.1.1 2002/03/24 12:37:03 dvermeir Exp $
#include <stdexcept>
#include <dvutil/file.h>
#include <dvutil/tostring.h>
#include <dvnet/socket.h>

using namespace Dv;

int
main( int argc , char* argv[] ) {
static const string usage("usage: test-server host port [large|dos|empty]");
static const string error("ERROR ");
try {
  // Get common parameters.
  if (argc!=4)
    throw runtime_error(usage);

  const string host(argv[1]);
  const int port(atoi(argv[2]));
  const string test(argv[3]);

  cout << "testing " << port << '@' << host << endl;

  // Use bufsize = 1024, delay = 1000 msec.
  Net::Socket server(host, port, 1024, 1000);
  if (!server)
    throw runtime_error(
           Util::tostring(port) + "@" + host + ": " + server.strerror()
	   );

  if (test=="large") {
    cout << "- send infinitely long command" << endl;

    server << "query " ;
    while (server) 
      server << "word ";
    }

  else if (test == "dos") {
    cout << "- delay sending command " << endl;
    while (server.error() == 0) 
      ;
    }

  else if (test == "empty-cmd") {
    cout << "- sending empty command " << endl;
    server << endl;
    }

  if (server) {
    string reply;
    while (getline(server,reply)) 
      cout << reply << endl;
    }
  cout << "server status = " << server.strerror() << endl;
  }
catch (exception& e) {
  cerr << error <<  e.what() << endl;
  return 1;
  }
return 0;
}
