// $Id: test-wordstreamiterator.C,v 1.1.1.1 2002/03/24 12:37:04 dvermeir Exp $
#include <fstream>
#include <algorithm>
#include <iterator>
#include "word.h"
#include "wordstreamiterator.h"

int
main() {
static const string ifn("test-wordstreamiterator.C");
try {
  set<string>	ignore;
  {
  // read ignore words
  ifstream ifs(ifn.c_str());
  copy(istream_iterator<Word>(ifs), istream_iterator<Word>(),
    inserter(ignore,ignore.end()));
  }
  
  ifstream ifs(ifn.c_str());
  wordstream_iterator i(ifs,ignore);
  copy(i, wordstream_iterator(), ostream_iterator<string>(cout,"\n"));
  cout << "read = " << i.read() << endl
       << "ignored = " << i.ignored() << endl;
  if (i.read())
    throw runtime_error("Expected to read no words");
  }
catch (exception& e) {
  cerr << e.what() << endl;
  return 1;
  }
return 0;
}
