// $Id: wordstreamiterator.C,v 1.1.1.1 2002/03/24 12:37:04 dvermeir Exp $

#include "wordstreamiterator.h"
#include "word.h"

wordstream_iterator::wordstream_iterator(istream& is,
  const set<string>& ignore): ignore_(&ignore), is_(&is), ok_(true),
  ignored_(0), read_(0) {
get();
}

wordstream_iterator::wordstream_iterator(): ignore_(0), is_(0), ok_(false) {
}

void
wordstream_iterator::get() {
if (!is_)
  throw logic_error("Cannot read from wordstream_iterator with null stream");
Word w;
ok_ = (*is_) ? true : false;
bool ignored(true);
if (ok_) {
  do {
    if (*is_ >> w) {
      value_ = w.str();
      if (ignored = ignore_->count(value_) )
        ++ignored_;
      }
    }
  while (*is_ &&  ignored);
  ok_ = (*is_ && !ignored);
  if (ok_)
    ++read_;
  }
}
